#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>

/********************************************************************/
/* Implementieren Sie die zwei Funktion caesar_encrypt und caesar_decrypt
   die alle Buchstaben in einem übergebenen String mithilfe der
   Caesar-Chiffre ver-, bzw. entschlüsseln.
	
*/

void caesar_encrypt(char *text, int key)
{
	int was_lower;
	for (; *text; text++) {
		if (!isalpha(*text))
			continue;
 
		was_lower = islower(*text);
		*text -= was_lower ? 'a' : 'A';
		*text = (*text + key) % 26;
		*text += was_lower ? 'a' : 'A';
	}
}

void caesar_decrypt(char *text, int key)
{
	int was_lower;
	for (; *text; text++) {
		if (!isalpha(*text))
			continue;
 
		was_lower = islower(*text);
		*text -= was_lower ? 'a' : 'A';
		*text = (*text - key + 26) % 26;
		*text += was_lower ? 'a' : 'A';
	}
}

/********************************************************************/

#define MAX_LEN 256

int main(int argc, char *argv[])
{
	if (argc < 5) {
		printf("Usage: %s [encrypt|decrypt] key input-file output-file\n", argv[0]);
		return 1;
	}
	char *action = argv[1];
	int key      = atoi(argv[2]);
	FILE *input  = fopen(argv[3], "r");
	FILE *output = fopen(argv[4], "w");

	char linebuf[MAX_LEN];

	/********************************************************************/
	/* Zusatzaufgabe: Überlegen Sie, ob Sie aus der Vorlesung ein Konstrukt
	   kennen um dies hier mit nur einer Schleife zu lesen (aber dennoch auch nur
	   maximal zwei Aufrufen an strcmp).

	 */
	if (strcmp("encrypt", argv[1]) == 0) { 
		while (fgets(linebuf, MAX_LEN, input)) {
			caesar_encrypt(linebuf, key);
			fputs(linebuf, output);
		}
	} else if (strcmp("decrypt", argv[1]) == 0) {
		while (fgets(linebuf, MAX_LEN, input)) {
			caesar_decrypt(linebuf, key);
			fputs(linebuf, output);
		}
	} else {
		printf("Invalid command.\n");
	}

	fclose(input);
	fclose(output);

	return 0;
}
