#include <stdlib.h>
#include "grading_table.h"

grading_table_ptr read_list(FILE *filep)
{
	/* Beware: No error detection or error handling whatso ever */
	grading_table_ptr head = NULL, tail = NULL;

	while (1) {
		grading_table_ptr new_entry = malloc(sizeof(struct grading_entry_t));
		fread(&new_entry->matrikelnummer, sizeof(new_entry->matrikelnummer), 1, filep);
		if (feof(filep)) {
			free(new_entry);
			return head;
		}
		fread(&new_entry->serie         , sizeof(new_entry->serie         ), 1, filep);
		fread(&new_entry->punkte        , sizeof(new_entry->punkte        ), 1, filep);
		new_entry->next = NULL;

		if (!head) {
			head = tail = new_entry;
		} else {
			tail->next = new_entry;
			tail = new_entry;
		}
	}

	return head;
}

void delete_list(grading_table_ptr head)
{
	grading_table_ptr tmp;
	while (head) {
		tmp = head->next;
		free(head);
		head = tmp;
	}
}

void traverse_list(grading_table_ptr head, void (*visitor)(grading_table_ptr current))
{
	while (head) {
		visitor(head);
		head = head->next;
	}
}

int reduce_list(grading_table_ptr head, int  (*visitor)(grading_table_ptr current, int val), int start_val)
{
	while (head) {
		start_val = visitor(head, start_val);
		head = head->next;
	}
	return start_val;
}
