#include <stdio.h>

#include "grading_table.h"

void taskA(grading_table_ptr current)
{
	printf("%d hat in %d %d Punkt(e) erreicht.\n", 
			current->matrikelnummer,
			current->serie,
			current->punkte
			);
}

void taskB(grading_table_ptr current)
{
	if (current->punkte < 10) {
		printf("%d %d\n", current->matrikelnummer, current->serie);
	}
}

int taskC(grading_table_ptr current, int val)
{
	return val + 1;
}

int taskD(grading_table_ptr current, int val)
{
	return (current->punkte > val) ? current->punkte : val;
}

int taskE(grading_table_ptr current, int val)
{
	return (current->serie == 3) ? val + current->punkte : val;
}

int main(int argc, char *argv[])
{
	if (argc < 2) {
		fprintf(stderr, "Usage: %s (a|b|c|d|e) [filename]\n", argv[0]);
		return 1;
	}
	
	char task = argv[1][0];
	FILE *input;

	if (argc == 3) {
		input = fopen(argv[2], "r");
	} else {
		input = stdin;
	}

	grading_table_ptr list = read_list(input);

	switch (task) {
		case 'a':
			traverse_list(list, taskA);
			break;
		case 'b':
			traverse_list(list, taskB);
			break;
		case 'c':
			printf("%d\n", reduce_list(list, taskC, 0));
			break;
		case 'd':
			printf("%d\n", reduce_list(list, taskD, 0));
			break;
		case 'e':
			printf("%d\n", reduce_list(list, taskE, 0));
			break;
		default:
			fprintf(stderr, "Unknown task: %c\n", task);
			return 2;
	}

	delete_list(list);

	return 0;
}
