# ifndef __i2stack_h
# define __i2stack_h

enum errorT { OK, NOT_INITIALIZED, EMPTY, NO_MEMORY };

/* NONE war nicht gefordert, doch hilft bei der Fehlerkommunikation */
enum discriminantT { INT, FLOAT, NONE };

typedef struct _stack* Stack;

typedef struct _numberT {
	enum discriminantT discr;
	/* Felder in anonymen unions (kein Name)
	   sind direkt in der übergeordneten Struktur abrufbar. 
	   Alternativ: union u {...} und dann überall number.u.as_int
	*/
	union {
		int as_int;
		float as_float;
	};
} numberT;

void push( Stack, numberT );
numberT pop( Stack );
numberT top( Stack );
void swap( Stack );

Stack allocStack();
void freeStack( Stack );

void print_error( Stack s ); 
enum errorT lastError( Stack s );

# endif

