/* AP 26-sep-12 test2stack.c			*/
/*		testdriver for Integer stack 	*/
/*		improved error handling		*/

# include <stdio.h>
# include <ctype.h>
# include <stdlib.h>
# include <string.h>
# include "i2stack.h"

# define LEN 80

static void get_input( char * command[], numberT * val ) {
	static char buf[LEN+1];
	int i;

	val->discr = NONE; 
	fgets( buf, LEN, stdin );
	buf[LEN] = '\0';
	for (i = 0; i < LEN; i++ ) 
		if (isspace( buf[i] )) {
			buf[i] = '\0';
			break;
		}
	for ( i++; i < LEN; i++ )
		if (!isspace( buf[i] ))  
			break;
	*command = buf;
	if (i < LEN) {
		if (strcmp( *command, "pushf" ) == 0) {
			val->discr = FLOAT;
			val->as_float= atof( &buf[i] );
		} else {
			val->discr = INT;
			val->as_int = atoi( &buf[i] );
		}
	}
}

static void print_value(char prefix[], numberT val) {
	if (val.discr == INT)
		printf("%s: value = %d (int)\n", prefix, val.as_int );
	else if (val.discr == FLOAT)
		printf("%s: value = %f (float)\n", prefix, val.as_float );
	else if (val.discr == NONE)
		printf("%s: value = NONE\n", prefix );
}

int main(int argc, char * argv[]) {
	char* prog = argv[0];
	int cont = 1;
	char * command;
	numberT val;
	Stack s = NULL;

	val.discr = INT;
	printf("%s: Integer/Float Stack mit Fehlercode in Stack-Struktur\n", prog);

	while( cont ) {
		printf("{init | push <int> | pushf <float> | pop | swap |"
			" top | free | quit}\n");
		get_input( &command, &val );

		if (strcmp( command, "init" ) == 0) {
			if (s) 
				printf("already initialized\n");
			else 	
				s = allocStack();
			print_error( s );
		} else if (strcmp( command, "push" ) == 0 || strcmp( command, "pushf" ) == 0) {
			push( s, val );
			print_error( s );
		} else if (strcmp( command, "pop" ) == 0) {
			val = pop( s );
			print_value("pop", val );
			print_error( s );
		} else if (strcmp( command, "swap" ) == 0) {
			swap( s );
			print_error( s );
		} else if (strcmp( command, "top" ) == 0) {
			val = top( s );
			print_value("top", val );
			print_error( s );
		} else if (strcmp(command, "free") == 0) {
			freeStack( s );
			s = (Stack) 0;
			print_error( s );				
		} else if (strcmp(command, "quit") == 0) {
			cont = 0;
		} else {
			printf("wie bitte?\n");
			print_error( s );
		}
	}
}
